/*-------------------------------------------------------------------------
	Copyright (C) 2008-2009 American Megatrends Inc.
	
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-------------------------------------------------------------------------*/
#ifndef	_I2C_DATA_H
#define	_I2C_DATA_H

#include <linux/i2c.h>

#define	TRANSFERSIZE			1024
#define	MAX_FIFO_LEN			8

#ifdef CFG_PROJ_I2C_USABLE_BUS
#define	BUS_COUNT			CFG_PROJ_I2C_USABLE_BUS	
#else
/* Default - All 6 VSC i2c bus are useable */
#define	BUS_COUNT			6
#endif

#define	DEFAULT_SLAVE_0			0x10
#define	DEFAULT_SLAVE_1			0x10
#define	DEFAULT_SLAVE_2			0x10
#define	DEFAULT_SLAVE_3			0x10
#define	DEFAULT_SLAVE_4			0x10
#define	DEFAULT_SLAVE_5			0x10

#define	STATE_IDLE			0
#define	STATE_MASTER_XMIT		1
#define	STATE_MASTER_RECV		2
#define	STATE_SLAVE			3
#define STATE_WAIT_FOR_STOP		4
#define STATE_WAIT_FOR_STOP_AFTER_NACK	5
#define STATE_MASTER_XMIT_RECV		6

struct i2c_vsc_data
{
	/* Buffer used for Master Transfer */
	unsigned char TX_data[TRANSFERSIZE];
	int TX_len;
	int TX_index;

	/* Buffer used for Master Receive */
	unsigned char MasterRX_data[TRANSFERSIZE];
	int MasterRX_len;
	int MasterRX_index;

/* JM: This driver supports master mode only. No need for slave mode support. */
#if 0
	unsigned char Linear_SlaveRX_data[TRANSFERSIZE];
	int Linear_SlaveRX_len;
	int Linear_SlaveRX_index;

	unsigned char SlaveRX_data[MAX_FIFO_LEN][TRANSFERSIZE];
	int SlaveRX_len[MAX_FIFO_LEN];
	int SlaveRX_index[MAX_FIFO_LEN];
	
	int SlaveRX_Writer;
	int SlaveRX_Reader;
	int SlaveRX_Entries;
#endif

	spinlock_t data_lock;

	volatile u32 op_status;

	int state;

	wait_queue_head_t vsc_wait;

	unsigned int bus_recovery_cnt;
	unsigned int bus_busy_cnt;
	unsigned char dev_fail_cnt[128];
	int scan;
	unsigned char slave_addr;
};

extern int i2c_vsc_add_bus(struct i2c_adapter *);
extern int i2c_vsc_del_bus(struct i2c_adapter *);
extern void i2c_init_internal_data(int	bus);
extern struct i2c_vsc_data vsc_data_ptr[BUS_COUNT];

#endif

